<template>
    <Form @submit="onSubmit" @invalid-submit="onInvalidSubmit" ref="theForm" v-slot="{ meta }">
        <loadingModal ref="loadingModal" />
        <div class="container-fluid page-container-grouped-styles">
            <div class="row justify-content-center">
                <div class="col-md-6">
                    <funnelHeader cmsWidgetName="FunnelHeaderWidget" ref="funnelHeader" />
                </div>
            </div>
            <div class="row justify-content-center">
                <div class="col-md-6 col-xl-4">
                    <funnelSubHeader cmsWidgetName="FunnelSubHeaderWidget" class="mt-4" />
                    <template v-if="ChangeShopLink.length">
                        <textBlock
                            cmsWidgetName="ChangeShopLink"
                            justifyText="center"
                            class="mb-3 text-link-small"
                            marginTopSizeOverride="1" />
                    </template>
                    <locationAlerts cmsWidgetPrefix="LocationAlert-" ref="locationAlerts" />
                    <datePicker
                        customComponentId="dateQuestion"
                        selectableDatesSetting="custom"
                        ref="datePicker"
                        v-model="selectedDate"
                        class="text-link-small"
                        :customSelectableDatesCallback="getAvailableDatesMethod"
                        validationRules="date-required"
                        @date-clicked="openInshopTimeSlotsModal" />
                    <timeSlotModalQuestion
                        ref="timeSlotModalQuestion"
                        customComponentId="timeSlotModalQuestion"
                        v-model="selectedTimeSlotInfo"
                        cmsWidgetName="TimeSlotModalQuestion"
                        mobilePremiumCmsWidgetName="MobilePremiumTimeSlotModal"
                        mobileCmsWidgetName="MobileTimeSlotModal"
                        dropoffCmsWidgetName="DropOffTimeSlotModal"
                        sameDayDropOffCmsWidgetName="SameDayDropOffTimeSlotModal"
                        overnightDropOffCmsWidgetName="OvernightDropOffTimeSlotModal"
                        :selectedDate="selectedDate"
                        :appointmentType="appointmentType"
                        :premiumAppointmentFee="mobilePremiumAppointmentFee"
                        :timeSlotsForSelectedDate="timeSlotsForSelectedDate"
                        :estimatedServiceMinutesMinimum="
                            selectableDatesData.estimatedServiceMinutesMinimum
                        "
                        :estimatedServiceMinutesMaximum="
                            selectableDatesData.estimatedServiceMinutesMaximum
                        "
                        @time-slot-modal-closed="timeSlotModalClosed"
                        validationRules="time-slot-selection-required"
                        @TimeSlotSelected="forwardButtonAction" />
                    <navbar
                        cmsWidgetName="FunnelFooterWidget"
                        ref="navbar"
                        :isForwardActionDisabled="!meta.valid"
                        @back-clicked="backButtonAction"
                        @ForwardClicked="forwardButtonAction" />
                </div>
            </div>
        </div>
    </Form>
</template>

<script>
// Components
import funnelHeader from "@/fmg-components/funnel-header/funnel-header";
import navbar from "@/fmg-components/nav-bar/nav-bar";
import funnelSubHeader from "@/fmg-components/funnel-sub-header/funnel-sub-header";
import loadingModal from "@/fmg-components/loading-modal/loading-modal.vue";
import { Form, defineRule } from "vee-validate";
import datePicker from "@/digital-components/date-picker/date-picker";
import locationAlerts from "@/layouts/schedule/location-alerts/location-alerts";
import timeSlotModalQuestion from "./time-slot-modal-question/time-slot-modal-question";
import textBlock from "@/digital-components/text-block/text-block";

// Supporting files
import { queryStrings } from "@/constants/query-strings";
import { getQuerystringParameter } from "@/helpers/querystring-helper";
import { fetchCmsContentForPage } from "@/helpers/cms-content-helper";
import baseMixin from "@/mixins/base-mixin.js";
import { storeActions } from "@/constants/store-actions";
import { settleAllPromises } from "@/helpers/layout-helper";
import { splitCopyOnCMSPlaceHolder } from "@/helpers/cms-content-helper";
import {
    calcDaysBetweenDates,
    convertDateStringToDate,
    sumDateString,
} from "@/layouts/schedule/helpers/schedule-helper";
import { AppointmentTypeStrings, PREMIUM_FEE_PART_TYPE } from "@/constants/schedule-constants";
import { errorMessages } from "@/constants/error-messages";
import { required } from "@/helpers/validation-rules";
import store from "@/store";

// DEFINE VALIDATION RULES
defineRule("date-required", required(errorMessages.DATE_REQUIRED));
defineRule("time-slot-selection-required", (value) => {
    if (value?.timeSlot?.routeCode == null) {
        return errorMessages.DATE_REQUIRED;
    }
    return true;
});

// Define constants
const TIME_SLOTS_CALL_DAYS_LIMIT = 34; // needs to be 34 for API limits (35 does not consistently work)

const getAvailableDates = async (
    startDateString,
    endDateString,
    appointmentType,
    providerNumber
) => {
    const apiEndDateLimit = sumDateString(startDateString, TIME_SLOTS_CALL_DAYS_LIMIT);
    const difference = calcDaysBetweenDates(startDateString, endDateString);
    const apiCallsCount = Math.ceil(difference / TIME_SLOTS_CALL_DAYS_LIMIT);
    const storeActionConfigs = [];
    const timeSlotsData = {};
    timeSlotsData.days = [];
    let apiStartDate = startDateString;
    let apiEndDate = endDateString;

    for (let i = 1; i <= apiCallsCount; i++) {
        let storeActionConfig;

        if (i > 1) {
            apiStartDate = sumDateString(apiEndDate, 1);
            apiEndDate = sumDateString(apiStartDate, TIME_SLOTS_CALL_DAYS_LIMIT);

            if (i === apiCallsCount) {
                apiEndDate = endDateString;
            }
        } else {
            if (apiEndDate > apiEndDateLimit) {
                apiEndDate = apiEndDateLimit;
            }
        }

        if (appointmentType === AppointmentTypeStrings.MOBILE) {
            storeActionConfig = {
                storeAction: storeActions.GET_MOBILE_TIME_SLOTS,
                payload: {
                    startDate: apiStartDate,
                    endDate: apiEndDate,
                },
            };
        } else {
            storeActionConfig = {
                storeAction: storeActions.GET_SHOP_TIME_SLOTS,
                payload: {
                    startDate: apiStartDate,
                    endDate: apiEndDate,
                    shopAppointmentType: appointmentType,
                    providerNumber: providerNumber,
                },
            };
        }
        if (apiStartDate < apiEndDate) storeActionConfigs.push(storeActionConfig);
    }

    const timeSlotsResponsesData = {
        days: [],
    };

    function compareDayStrings(a, b) {
        if (a.date < b.date) return -1;
        if (a.date > b.date) return 1;
        return 0;
    }

    const makeParallelCalls = async () => {
        await Promise.all(
            storeActionConfigs.map(async (storeAction) => {
                const timeSlotsResponse = await baseMixin.methods.dispatchStoreActionWithLogging(
                    storeAction.storeAction,
                    storeAction.payload,
                    "schedule",
                    false
                );
                timeSlotsResponsesData.estimatedServiceMinutesMinimum =
                    timeSlotsResponse.data.estimatedServiceMinutesMinimum;
                timeSlotsResponsesData.estimatedServiceMinutesMaximum =
                    timeSlotsResponse.data.estimatedServiceMinutesMaximum;
                timeSlotsResponsesData.days = [
                    ...timeSlotsResponsesData.days,
                    ...timeSlotsResponse.data.days,
                ];
            })
        );
    };

    return makeParallelCalls().then(() => {
        // sort days chronologically
        timeSlotsResponsesData.days.sort(compareDayStrings);
        return timeSlotsResponsesData;
    });
};

export default {
    name: "schedule",
    data() {
        return {
            selectedDate: this.getSelectedDate(),
            selectedTimeSlotInfo: this.getSelectedTimeSlotInfo(),
            selectableDatesData: [],
            mobilePremiumAppointmentFee: null,
        };
    },
    async beforeRouteEnter(to, from, next) {
        // Call APIs
        const cmsContentPromise = fetchCmsContentForPage(to.query.fmgPage);
        let preSelectedDate = await store.getters.order.schedule.date;
        if (!preSelectedDate || preSelectedDate.startTime === null) {
            preSelectedDate = null;
        }

        const datePickerInitialDataPromise = await datePicker.methods.loadInitialData({
            // setup config options for date-picker
            selectableDatesSetting: "custom",
            initialViewRowsToShow: 5,
            customSelectableDatesCallback: getAvailableDates,
            preSelectedDate: preSelectedDate,
        });

        const premiumFeePromise = baseMixin.methods.dispatchStoreActionWithLogging(
            storeActions.GET_MOBILE_PREMIUM_FEE,
            null,
            "schedule"
        );

        const premiumFeeWithPricePromise = premiumFeePromise.then((result) => {
            if (result.data) {
                return baseMixin.methods.dispatchStoreActionWithLogging(
                    storeActions.PRICE_ORDER_ITEMS_AND_SAVE_SERVER_DATA,
                    {
                        availableLineItems: [result.data],
                    },
                    "schedule",
                    false
                );
            } else {
                return result.data;
            }
        });

        const alertReasonsPromise = locationAlerts.methods.loadInitialData(
            store.getters.order.serviceLocation.zipCodeCtu,
            store.getters.order.serviceLocation.provider?.address?.zipCodeCtu
        );

        // Settle promises and get results
        const promiseResultMap = [
            {
                resultKey: "cmsContent",
                promise: cmsContentPromise,
            },
            {
                resultKey: "alertReasons",
                promise: alertReasonsPromise,
            },
            {
                resultKey: "datePickerInitialData",
                promise: datePickerInitialDataPromise,
            },
            {
                resultKey: "premiumFeeWithPrice",
                promise: premiumFeeWithPricePromise,
            },
        ];

        const resultMap = await settleAllPromises(promiseResultMap);

        // Call the "next" function to complete the transition to this page.
        next((vm) => {
            vm.setCmsContent(resultMap.cmsContent);
            vm.$refs.datePicker.initializeComponent(resultMap.datePickerInitialData);
            vm.$refs.locationAlerts.initializeComponent(resultMap.alertReasons);
            vm.selectableDatesData = resultMap.datePickerInitialData.initialShopTimeSlotsResponse;
            vm.mobilePremiumAppointmentFee = resultMap.premiumFeeWithPrice
                ? resultMap.premiumFeeWithPrice[0]
                : null;
            vm.updateFooterButtonText(vm.selectedTimeSlotInfo);
        });
    },
    computed: {
        ChangeShopLinkText() {
            return this.getCmsContent("ChangeShopLink", "Text");
        },
        ChangeShopLink() {
            // Splits content when brackets are found in text so that text can be looped through and router-link can be injected when needed
            return this.splitCopyOnCMSPlaceHolder(this.ChangeShopLinkText);
        },
        appointmentType() {
            return this.$store.getters.order.serviceLocation.appointmentType;
        },
        timeSlotsForSelectedDate() {
            if (!this.selectedDate) {
                return null;
            }

            return this.selectableDatesData.days?.find(
                (selectableDate) => selectableDate.date === this.selectedDate
            );
        },
    },
    methods: {
        splitCopyOnCMSPlaceHolder,
        arePagePrerequisitesValid() {
            const serviceLocation = store.getters.order.serviceLocation;

            const serviceLocationPreReqs =
                serviceLocation.zipCode &&
                serviceLocation.zipCodeCtu &&
                serviceLocation.appointmentType &&
                (serviceLocation.appointmentType === AppointmentTypeStrings.MOBILE ||
                    serviceLocation.provider.providerNumber);

            const paymentInfo = store.getters.payment.isInsurance !== null;

            const damageInfo =
                store.getters.order.damage.isRepair ||
                (store.getters.order.lineItems?.glassParts != null &&
                    store.getters.order.lineItems.glassParts.length > 0);

            const preReqResult = serviceLocationPreReqs && paymentInfo && damageInfo;

            // prettier-ignore
            {
                const log = getQuerystringParameter(queryStrings.LOG);
                if (log === "true" || !preReqResult) {
                    console.log("------------- schedule.vue pagePrereqs start -----------------");
                    console.log(new Date() + " store.getters.order.serviceLocation.zipCode: " + serviceLocation.zipCode);
                    console.log(new Date() + " store.getters.order.serviceLocation.zipCodeCtu: " + serviceLocation.zipCodeCtu);
                    console.log(new Date() + " store.getters.order.serviceLocation.appointmentType: " + serviceLocation.appointmentType);
                    console.log(new Date() + " store.getters.order.serviceLocation.provider.providerNumber: " + serviceLocation.provider.providerNumber);
                    console.log(new Date() + " store.getters.payment.isInsurance: " + store.getters.payment?.isInsurance);
                    console.log(new Date() + " store.getters.order.damage.isRepair: " + store.getters.order.damage.isRepair);
                    console.log(new Date() + " store.getters.order.lineItems.glassParts: " + JSON.stringify(store.getters.order.lineItems?.glassParts));
                    console.log("------------- schedule.vue pagePrereqs end -------------------");
                }
            }
            return preReqResult;
        },
        async getAvailableDatesMethod(startDate, endDate) {
            const newShopTimeSlots = await getAvailableDates(
                startDate,
                endDate,
                this.appointmentType,
                this.$store.getters.order.serviceLocation.provider.providerNumber
            );
            // ADD API CALL RESULTS TO EXISTING DATE DATA
            this.selectableDatesData.days = this.selectableDatesData.days.concat(
                newShopTimeSlots.days
            );
            return newShopTimeSlots;
        },
        getAvailableDates,
        getServiceZipCtuCodeFromStore() {
            return store.getters.order.serviceLocation.zipCodeCtu;
        },
        openInshopTimeSlotsModal() {
            this.$refs["timeSlotModalQuestion"].openModal();
        },
        getSelectedDate() {
            return store.getters.order.schedule.date;
        },
        getSelectedTimeSlotInfo() {
            const supportingItems = this.getSupportingItems();

            var isPremiumAppointment = false;
            if (supportingItems) {
                isPremiumAppointment =
                    !!supportingItems.filter(
                        (lineItem) => lineItem.partType === PREMIUM_FEE_PART_TYPE
                    ).length > 0;
            }

            const selectedTimeSlotInfo = {
                timeSlot: store.getters.order.schedule,
                isPremiumAppointment: isPremiumAppointment,
            };

            return selectedTimeSlotInfo;
        },
        getSupportingItems() {
            return store.getters.lineItems.supportingItems;
        },
        timeSlotModalClosed() {
            // Clear the selectedDate if no timeSlot has been selected
            if (this.selectedTimeSlotInfo.timeSlot.routeCode == null) {
                this.selectedDate = null;
            }
        },
        updateFooterButtonText(timeSlotInfo) {
            let navbarButtonText;
            if (!timeSlotInfo || !timeSlotInfo.timeSlot.date) {
                navbarButtonText = "Continue";
            } else {
                navbarButtonText = `Select ${this.convertSelectedDateToShortMonthAndDay(
                    timeSlotInfo.timeSlot.date
                )}`;

                if (this.appointmentType === AppointmentTypeStrings.IN_SHOP) {
                    navbarButtonText += ` at ${this.getDisplayTextForMilitaryTime(
                        timeSlotInfo.timeSlot.startTime
                    )}`;
                } else if (
                    this.appointmentType === AppointmentTypeStrings.MOBILE &&
                    !timeSlotInfo.isPremiumAppointment
                ) {
                    navbarButtonText += ` at ${this.getDisplayTextForMilitaryTime(
                        timeSlotInfo.timeSlot.startTime,
                        true
                    )} - ${this.getDisplayTextForMilitaryTime(
                        timeSlotInfo.timeSlot.endTime,
                        true
                    )}`;
                }
            }
            this.$refs.navbar.updateButtonText(navbarButtonText);
        },
        convertSelectedDateToShortMonthAndDay(selectedDate) {
            // This conversion ensures we don't get get GMT induced date changes
            const dateObject = convertDateStringToDate(selectedDate);
            // Ex: April 25
            return dateObject.toLocaleDateString("en-us", { month: "short", day: "numeric" });
        },
        getDisplayTextForMilitaryTime(militaryTimeInput, shouldTrimMinutesIfEmpty = false) {
            // Expected input: "HH:MM"
            let hours = parseInt(militaryTimeInput.split(":")[0]);
            const minutes = militaryTimeInput.split(":")[1];
            const meridianNotation = hours > 11 ? "PM" : "AM";

            if (hours > 12) {
                hours -= 12;
            }

            if (shouldTrimMinutesIfEmpty && minutes === "00") {
                return `${hours} ${meridianNotation}`;
            } else {
                return `${hours}:${minutes} ${meridianNotation}`;
            }
        },
        backButtonAction() {
            this.$router.navigateWithoutSaving(this.navigationScenarios.CLICKED_BACK, this.$route);
        },
        forwardButtonAction() {
            this.updateSupportingItems();

            if (this.selectedTimeSlotInfo.timeSlot.jobMinMinutes == null) {
                this.selectedTimeSlotInfo.timeSlot.jobMinMinutes =
                    this.selectableDatesData?.estimatedServiceMinutesMinimum?.toString();
                this.selectedTimeSlotInfo.timeSlot.jobMaxMinutes =
                    this.selectableDatesData?.estimatedServiceMinutesMaximum?.toString();
            }

            this.dispatchStoreAction(
                this.storeActions.SAVE_SCHEDULE,
                this.selectedTimeSlotInfo.timeSlot,
                false
            );

            this.$router.navigateWithSaving(this.navigationScenarios.CLICKED_FORWARD, this.$route);
        },
        updateSupportingItems() {
            const supportingItems = this.getSupportingItems();

            // if we have a premium fee(early bird), then save/update supporting items
            if (
                this.appointmentType === AppointmentTypeStrings.MOBILE &&
                this.selectedTimeSlotInfo?.isPremiumAppointment
            ) {
                const premiumFeeIndex = supportingItems.findIndex(
                    (item) => item.partType == PREMIUM_FEE_PART_TYPE
                );

                if (premiumFeeIndex >= 0) {
                    supportingItems[premiumFeeIndex].laborAmount =
                        this.mobilePremiumAppointmentFee.laborAmount;
                    supportingItems[premiumFeeIndex].sellingPrice =
                        this.mobilePremiumAppointmentFee.sellingPrice;
                    supportingItems[premiumFeeIndex].kitPrice =
                        this.mobilePremiumAppointmentFee.kitPrice;
                } else {
                    supportingItems.push(this.mobilePremiumAppointmentFee);
                }

                this.dispatchStoreAction(
                    this.storeActions.SAVE_SUPPORTING_ITEMS_SUPPRESSING_STATE_RESETTING,
                    supportingItems,
                    false
                );
            } else {
                if (!supportingItems) {
                    return;
                }

                // if it's not a mobile and/or premium early bird, then make sure we remove any that may have been added
                const removePremiumFeeIndex = supportingItems.findIndex(
                    (item) => item.partType == PREMIUM_FEE_PART_TYPE
                );

                if (removePremiumFeeIndex >= 0) {
                    supportingItems.splice(removePremiumFeeIndex, 1);
                    this.dispatchStoreAction(
                        this.storeActions.SAVE_SUPPORTING_ITEMS_SUPPRESSING_STATE_RESETTING,
                        supportingItems,
                        false
                    );
                }
            }
        },
    },
    watch: {
        selectedDate(newValue, oldValue) {
            // Clear time slot selection if date selected changes
            if (newValue !== oldValue) {
                this.selectedTimeSlotInfo = {
                    timeSlot: {
                        date: null,
                        routeCode: null,
                        startTime: null,
                        endTime: null,
                        jobMaxMinutes: null,
                        jobMinMinutes: null,
                    },
                    isPremiumAppointment: null,
                };
            }
        },
        selectedTimeSlotInfo(newValue) {
            this.updateFooterButtonText(newValue);
        },
    },
    components: {
        funnelHeader,
        navbar,
        funnelSubHeader,
        Form,
        loadingModal,
        datePicker,
        locationAlerts,
        timeSlotModalQuestion,
        textBlock,
    },
};
</script>

<style lang="scss">
.text-link-small {
    a,
    .btn-link {
        width: auto;
        margin: 0 auto;
        height: auto;
        font-size: 0.875rem;
        line-height: 1.5;
        padding: 0;
        border-radius: 0;
        &:focus {
            outline: 1px solid $blue;
        }
    }
}
.funnel-sub-header {
    h5.dark-header {
        margin-bottom: 0.25rem;
    }
}
</style>
